Index: socket.c
===================================================================
RCS file: /home/wine/wine/dlls/winsock/socket.c,v
retrieving revision 1.207
diff -u -r1.207 socket.c
--- dlls/winsock/socket.c	5 Feb 2006 12:58:22 -0000	1.207
+++ dlls/winsock/socket.c	7 Feb 2006 15:19:06 -0000
@@ -410,6 +410,21 @@
     SERVER_END_REQ;
 }
 
+static int _is_listening_or_connected(SOCKET s)
+{
+    int ret;
+    SERVER_START_REQ( get_socket_event )
+    {
+        req->handle  = SOCKET2HANDLE(s);
+        req->service = FALSE;
+        req->c_event = 0;
+        wine_server_call( req );
+        ret = (reply->state & (FD_WINE_LISTENING|FD_WINE_CONNECTED)) != 0;
+    }
+    SERVER_END_REQ;
+    return ret;
+}
+
 static int _is_blocking(SOCKET s)
 {
     int ret;
@@ -624,7 +639,7 @@
     return optval != 0;
 }
 
-static int fd_set_export( const fd_set* fds, fd_set* exceptfds, WS_fd_set* wsfds, int lfd[] )
+static int fd_set_export( const fd_set* fds, fd_set* exceptfds, WS_fd_set* wsfds, int lfd[], int *num_fds )
 {
     int num_err = 0;
 
@@ -642,12 +657,19 @@
             if (fd == -1) continue;
             if( FD_ISSET(fd, fds) )
             {
-                if ( exceptfds && sock_error_p(fd) )
+                if (_is_listening_or_connected(s))
+                {
+                    if ( exceptfds && sock_error_p(fd) )
+                    {
+                        FD_SET(fd, exceptfds);
+                        num_err++;
+                    }
+                    else wsfds->fd_array[j++] = s;
+                }
+                else
                 {
-                    FD_SET(fd, exceptfds);
-                    num_err++;
+                    --(*num_fds);
                 }
-                else wsfds->fd_array[j++] = s;
             }
             release_sock_fd( s, fd );
 	}
@@ -2451,8 +2473,8 @@
 
     if( (highfd = select(highfd + 1, p_read, p_write, p_except, timeoutaddr)) > 0 )
     {
-        fd_set_export(&readfds, p_except, ws_readfds, readfd);
-        fd_set_export(&writefds, p_except, ws_writefds, writefd);
+        fd_set_export(&readfds, p_except, ws_readfds, readfd, &highfd);
+        fd_set_export(&writefds, p_except, ws_writefds, writefd, &highfd);
 
         if (p_except && ws_exceptfds)
         {
